#include "bravesoldier.h"
#include "cowardsoldier.h"
#include "assaultsquad.h"

using namespace std;

int main()
{
	cout << endl;
	cout << "*************************************" << endl;
	cout << "**          Game Patterns          **" << endl;
	cout << "**             Mediator            **" << endl;
	cout << "*************************************" << endl;
	cout << "**       Christoph Stallmann       **" << endl;
	cout << "**      University of Pretoria     **" << endl;
	cout << "**          COS121 - 2012          **" << endl;
	cout << "*************************************" << endl;
	cout << endl;

	Soldier *soldier1 = new BraveSoldier();
	Soldier *soldier2 = new CowardSoldier();
	Soldier *soldier3 = new BraveSoldier();
	Soldier *soldier4 = new CowardSoldier();

	Squad *squad = new AssaultSquad();
	squad->add(soldier1);
	squad->add(soldier2);
	squad->add(soldier3);
	squad->add(soldier4);

	soldier2->inspect();
	cout << endl;
	soldier3->inspect();
	cout << endl;
	
	delete soldier1;
	delete soldier2;
	delete soldier3;
	delete soldier4;
	delete squad;

	return 0;
}
